function q=nmi(p1, p2)
% normalized mutual information
% p1 - partition 1
% p2 - partition 2

n1=max(p1);     % number of groups
n2=max(p2);
n=length(p1);
N=zeros(n1,n2);

for i=1:n,
    N(p1(i),p2(i))=N(p1(i),p2(i))+1;
end;

s1=sum(N,2);
s2=sum(N);

S1=s1*ones(1,n2);
S2=ones(n1,1)*s2;
t=N.*log(N.*n./(S1.*S2));
t(isnan(t))=0;
nom=(-2)*sum(sum(t));
denom=sum(s1.*log(s1./n))+sum(s2.*log(s2./n));
q=nom/denom;

