function d=pth2(GO,term)
% calculates soft representation of a GO term (based on a path distance to its relatives)
% GO - gene ontology object
% term - given GO term id

    anc=double(getancestors1(GO,term));
    des=double(getdescendants1(GO,term));
    termidx=(anc==1);
    d=(anc+des)-1;
    d=exp(-double(d));
    d(d>1)=0;
    d(termidx)=1;